'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getSymbolByAsset = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(tokenRegistryAddress, asset) {
    var aaStateVars;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(asset === null || asset === 'base')) {
              _context.next = 2;
              break;
            }

            return _context.abrupt('return', 'GBYTE');

          case 2:
            if (!(typeof asset !== 'string')) {
              _context.next = 4;
              break;
            }

            return _context.abrupt('return', null);

          case 4:
            if (_utils2.default.isValidAddress(tokenRegistryAddress)) {
              _context.next = 6;
              break;
            }

            return _context.abrupt('return', null);

          case 6:
            _context.next = 8;
            return this.getAaStateVars({
              address: tokenRegistryAddress,
              var_prefix: 'a2s_' + asset
            });

          case 8:
            aaStateVars = _context.sent;

            if (!('a2s_' + asset in aaStateVars)) {
              _context.next = 11;
              break;
            }

            return _context.abrupt('return', aaStateVars['a2s_' + asset]);

          case 11:
            return _context.abrupt('return', asset.replace(/[+=]/, '').substr(0, 6));

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getSymbolByAsset(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var getAssetBySymbol = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(tokenRegistryAddress, symbol) {
    var aaStateVars;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(typeof symbol !== 'string')) {
              _context2.next = 2;
              break;
            }

            return _context2.abrupt('return', null);

          case 2:
            if (!(symbol === 'GBYTE' || symbol === 'MBYTE' || symbol === 'KBYTE' || symbol === 'BYTE')) {
              _context2.next = 4;
              break;
            }

            return _context2.abrupt('return', 'base');

          case 4:
            if (_utils2.default.isValidAddress(tokenRegistryAddress)) {
              _context2.next = 6;
              break;
            }

            return _context2.abrupt('return', null);

          case 6:
            _context2.next = 8;
            return this.getAaStateVars({
              address: tokenRegistryAddress,
              var_prefix: 's2a_' + symbol
            });

          case 8:
            aaStateVars = _context2.sent;

            if (!('s2a_' + symbol in aaStateVars)) {
              _context2.next = 11;
              break;
            }

            return _context2.abrupt('return', aaStateVars['s2a_' + symbol]);

          case 11:
            return _context2.abrupt('return', null);

          case 12:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getAssetBySymbol(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

var getDecimalsBySymbolOrAsset = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(tokenRegistryAddress, symbolOrAsset) {
    var asset, _aaStateVarsWithPrefix, aaStateVarsWithPrefix, descHash, decimalsStateVar, decimals;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (_utils2.default.isValidAddress(tokenRegistryAddress)) {
              _context3.next = 2;
              break;
            }

            throw Error('Not valid tokenRegistryAddress');

          case 2:
            if (symbolOrAsset) {
              _context3.next = 4;
              break;
            }

            throw Error('symbolOrAsset is undefined');

          case 4:
            if (!(typeof symbolOrAsset !== 'string')) {
              _context3.next = 6;
              break;
            }

            throw Error('not valid symbolOrAsset');

          case 6:
            if (!(symbolOrAsset === 'base' || symbolOrAsset === 'GBYTE')) {
              _context3.next = 8;
              break;
            }

            return _context3.abrupt('return', 9);

          case 8:
            asset = void 0;

            if (!(symbolOrAsset.length === 44)) {
              _context3.next = 13;
              break;
            }

            asset = symbolOrAsset;
            _context3.next = 23;
            break;

          case 13:
            if (!(symbolOrAsset === symbolOrAsset.toUpperCase())) {
              _context3.next = 22;
              break;
            }

            _context3.next = 16;
            return this.getAaStateVars({
              address: tokenRegistryAddress,
              var_prefix: 's2a_' + symbolOrAsset
            });

          case 16:
            _aaStateVarsWithPrefix = _context3.sent;

            if ('s2a_' + symbolOrAsset in _aaStateVarsWithPrefix) {
              _context3.next = 19;
              break;
            }

            throw Error('no such symbol ' + symbolOrAsset);

          case 19:

            asset = _aaStateVarsWithPrefix['s2a_' + symbolOrAsset];
            _context3.next = 23;
            break;

          case 22:
            throw Error('not valid symbolOrAsset');

          case 23:
            _context3.next = 25;
            return this.getAaStateVars({
              address: tokenRegistryAddress,
              var_prefix: 'current_desc_' + asset
            });

          case 25:
            aaStateVarsWithPrefix = _context3.sent;

            if ('current_desc_' + asset in aaStateVarsWithPrefix) {
              _context3.next = 28;
              break;
            }

            throw Error('no decimals for ' + symbolOrAsset);

          case 28:
            descHash = aaStateVarsWithPrefix['current_desc_' + asset];
            _context3.next = 31;
            return this.getAaStateVars({
              address: tokenRegistryAddress,
              var_prefix: 'decimals_' + descHash
            });

          case 31:
            decimalsStateVar = _context3.sent;
            decimals = decimalsStateVar['decimals_' + descHash];

            if (!(typeof decimals !== 'number')) {
              _context3.next = 37;
              break;
            }

            throw Error('no decimals for ' + symbolOrAsset);

          case 37:
            return _context3.abrupt('return', decimals);

          case 38:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function getDecimalsBySymbolOrAsset(_x5, _x6) {
    return _ref3.apply(this, arguments);
  };
}();

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getOfficialTokenRegistryAddress() {
  return 'O6H6ZIFI57X3PLTYHOCVYPP5A553CYFQ';
}

exports.default = {
  getSymbolByAsset: getSymbolByAsset,
  getAssetBySymbol: getAssetBySymbol,
  getOfficialTokenRegistryAddress: getOfficialTokenRegistryAddress,
  getDecimalsBySymbolOrAsset: getDecimalsBySymbolOrAsset
};
module.exports = exports.default;